      program barrier
      implicit none
      include 'mpif.h'

      real*8         t0, t1, t2, tbmax
      integer      com, nproc, myid, ierr, i

      com = MPI_COMM_WORLD
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )

      call MPI_BARRIER( com, ierr )
      t0 = MPI_WTIME()
      t1 = MPI_WTIME()
      call MPI_BARRIER( com, ierr )
      t2 = MPI_WTIME() -t1
 110  format(i2,'  >> start time, duration :',2e8.1)
      call MPI_REDUCE( t2, tbmax, 1, MPI_DOUBLE_PRECISION, 
     :                 MPI_MAX, 0, com, ierr )
      if (myid.eq.0) then
      write(6,111) tbmax , tbmax*2600.0e+6
 111  format("MPI_BARRIER takes ",e10.2,"sec , i.e.",
     :        f8.0," cycles of 1./2.6e9 sec") 
      end if
      call MPI_FINALIZE( ierr )

      stop
      end













