      program errexit
      implicit none
c FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer myid, nproc, ierr
      integer iw, iex, iexglob, il, iproot
c---------------------------------------------------------- 
c        start MPI
c----------------------------------------------------------
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      iproot = 0
c----------------------------------------------------------
c        input
c----------------------------------------------------------
      if (myid.eq.iproot) then
         write(6,*)'iw ?'
         read(5,*) iw
      end if
      call MPI_BCAST(iw,1,MPI_INTEGER,iproot,MPI_COMM_WORLD,ierr)

      do il = 0 , iw
         call work(il,iex) 
         call MPI_REDUCE(iex,iexglob,1,MPI_INTEGER,MPI_MIN,iproot
     :                   ,MPI_COMM_WORLD,ierr) 
         call MPI_BCAST(iexglob,1,MPI_INTEGER,iproot
     :                 ,MPI_COMM_WORLD,ierr)
         if (iexglob.lt.0) then
            write(6,*) 'error exit on ',myid,' : ', il, iexglob, iex
            exit
         end if
      end do
      if (iexglob.ge.0) write(6,*) 'normal program end'

      call MPI_FINALIZE (ierr)

      stop
      end




      subroutine work(iw,iex)
      implicit none
c FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer iw, iex
      integer myid, nproc, ierr

      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )

      iex = 0
      if(iw+myid.gt.10) iex = -1

      return
      end
















