      subroutine iexchange ( n1, n2, a, req )
      implicit none
      include 'mpif.h'
      integer            n1, n2, req(4)
      real*8             a(0:n1+1,0:n2+1)
      integer            ipr, ipl, com, nproc, myid, ierr
  
      com = MPI_COMM_WORLD 
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )

      ipl = myid - 1
      if (myid.eq.0) ipl = MPI_PROC_NULL
      ipr = myid + 1
      if (myid.eq.nproc-1) ipr = MPI_PROC_NULL
      call MPI_ISEND(a(1,1), n1, MPI_DOUBLE_PRECISION, ipl, 0,
     :                 MPI_COMM_WORLD, req(1), ierr )
      call MPI_ISEND(a(1,n2), n1, MPI_DOUBLE_PRECISION, ipr, 0,
     :                 MPI_COMM_WORLD, req(2), ierr )
      call MPI_IRECV(a(1,0), n1, MPI_DOUBLE_PRECISION, ipl, 0,
     :                 MPI_COMM_WORLD, req(3), ierr )
      call MPI_IRECV(a(1,n2+1), n1, MPI_DOUBLE_PRECISION, ipr, 0,
     :                 MPI_COMM_WORLD, req(4), ierr )

      return
      end
