      subroutine randaustausch ( n1, n2, a )
      implicit none
      include 'mpif.h'
      integer            n1, n2
      real*8             a(0:n1+1,0:n2+1)
      integer            ipr, ipl, com, nproc, myid, ierr, 
     :                   istat(MPI_STATUS_SIZE)
   
      com = MPI_COMM_WORLD
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )

      ipl = myid - 1
      if (myid.eq.0) ipl = MPI_PROC_NULL
      ipr = myid + 1
      if (myid.eq.nproc-1) ipr = MPI_PROC_NULL
!  myid sends 1-th column to myid-1
!  and receives data for its 0-th column from myid-1
      call MPI_SENDRECV(a(1,1), n1, MPI_DOUBLE_PRECISION, ipl, 0,
     :                  a(1,0), n1, MPI_DOUBLE_PRECISION, ipl, 0, 
     :                  com, istat, ierr)
!  myid sends n2-th column to myid+1
!  and receives data for its n2+1-th column from myid+1
      call MPI_SENDRECV(a(1,n2), n1, MPI_DOUBLE_PRECISION, ipr, 0,
     :                  a(1,n2+1), n1, MPI_DOUBLE_PRECISION, ipr, 0, 
     :                  com, istat, ierr)

      return
      end
